#ifndef __LIBDXFEEDGRAALNATIVEAPI_H
#define __LIBDXFEEDGRAALNATIVEAPI_H

#include <graal_isolate.h>


#if defined(__cplusplus)
extern "C" {
#endif

dxfg_exception_t* dxfg_get_and_clear_thread_exception_t(graal_isolatethread_t*);

void dxfg_Exception_release(graal_isolatethread_t*, dxfg_exception_t*);

dxfg_endpoint_builder_t* dxfg_DXEndpoint_newBuilder(graal_isolatethread_t*);

int dxfg_DXEndpoint_Builder_withRole(graal_isolatethread_t*, dxfg_endpoint_builder_t*, dxfg_endpoint_role_t);

int dxfg_DXEndpoint_Builder_withName(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*);

int dxfg_DXEndpoint_Builder_withProperty(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*, char*);

int dxfg_DXEndpoint_Builder_withProperties(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*);

int dxfg_DXEndpoint_Builder_supportsProperty(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*);

dxfg_endpoint_t* dxfg_DXEndpoint_Builder_build(graal_isolatethread_t*, dxfg_endpoint_builder_t*);

dxfg_endpoint_t* dxfg_DXEndpoint_getInstance(graal_isolatethread_t*);

dxfg_endpoint_t* dxfg_DXEndpoint_getInstance2(graal_isolatethread_t*, dxfg_endpoint_role_t);

dxfg_endpoint_t* dxfg_DXEndpoint_create(graal_isolatethread_t*);

dxfg_endpoint_t* dxfg_DXEndpoint_create2(graal_isolatethread_t*, dxfg_endpoint_role_t);

int dxfg_DXEndpoint_close(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_closeAndAwaitTermination(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_getRole(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_user(graal_isolatethread_t*, dxfg_endpoint_t*, char*);

int dxfg_DXEndpoint_password(graal_isolatethread_t*, dxfg_endpoint_t*, char*);

int dxfg_DXEndpoint_connect(graal_isolatethread_t*, dxfg_endpoint_t*, char*);

int dxfg_DXEndpoint_reconnect(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_disconnect(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_disconnectAndClear(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_awaitProcessed(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_awaitNotConnected(graal_isolatethread_t*, dxfg_endpoint_t*);

int dxfg_DXEndpoint_getState(graal_isolatethread_t*, dxfg_endpoint_t*);

dxfg_endpoint_state_change_listener_t* dxfg_PropertyChangeListener_new(graal_isolatethread_t*, dxfg_endpoint_state_change_listener_func, void*);

int dxfg_DXEndpoint_addStateChangeListener(graal_isolatethread_t*, dxfg_endpoint_t*, dxfg_endpoint_state_change_listener_t*);

int dxfg_DXEndpoint_removeStateChangeListener(graal_isolatethread_t*, dxfg_endpoint_t*, dxfg_endpoint_state_change_listener_t*);

dxfg_feed_t* dxfg_DXEndpoint_getFeed(graal_isolatethread_t*, dxfg_endpoint_t*);

dxfg_publisher_t* dxfg_DXEndpoint_getPublisher(graal_isolatethread_t*, dxfg_endpoint_t*);

dxfg_executor_t* dxfg_Executors_newFixedThreadPool(graal_isolatethread_t*, int, char*);

int dxfg_DXEndpoint_executor(graal_isolatethread_t*, dxfg_endpoint_t*, dxfg_executor_t*);

dxfg_event_clazz_list_t* dxfg_DXEndpoint_getEventTypes(graal_isolatethread_t*, dxfg_endpoint_t*);

dxfg_symbol_t* dxfg_Symbol_new(graal_isolatethread_t*, char*, dxfg_symbol_type_t);

int dxfg_Symbol_release(graal_isolatethread_t*, dxfg_symbol_t*);

dxfg_event_type_t* dxfg_EventType_new(graal_isolatethread_t*, char*, dxfg_event_clazz_t);

int dxfg_EventType_release(graal_isolatethread_t*, dxfg_event_type_t*);

int dxfg_CList_EventType_release(graal_isolatethread_t*, dxfg_event_type_list*);

int dxfg_CList_EventClazz_release(graal_isolatethread_t*, dxfg_event_clazz_list_t*);

int dxfg_CList_symbol_release(graal_isolatethread_t*, dxfg_symbol_list*);

dxfg_indexed_event_source_t* dxfg_IndexedEventSource_new(graal_isolatethread_t*, char*);

int dxfg_IndexedEventSource_release(graal_isolatethread_t*, dxfg_indexed_event_source_t*);

dxfg_indexed_event_source_t* dxfg_IndexedEvent_getSource(graal_isolatethread_t*, dxfg_event_type_t*);

dxfg_feed_t* dxfg_DXFeed_getInstance(graal_isolatethread_t*);

dxfg_subscription_t* dxfg_DXFeed_createSubscription(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t);

dxfg_subscription_t* dxfg_DXFeed_createSubscription2(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_list_t*);

dxfg_time_series_subscription_t* dxfg_DXFeed_createTimeSeriesSubscription(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t);

dxfg_time_series_subscription_t* dxfg_DXFeed_createTimeSeriesSubscription2(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_list_t*);

int dxfg_DXFeedTimeSeriesSubscription_setFromTime(graal_isolatethread_t*, dxfg_time_series_subscription_t*, long long int);

int dxfg_DXFeed_attachSubscription(graal_isolatethread_t*, dxfg_feed_t*, dxfg_subscription_t*);

int dxfg_DXFeed_detachSubscription(graal_isolatethread_t*, dxfg_feed_t*, dxfg_subscription_t*);

int dxfg_DXFeed_detachSubscriptionAndClear(graal_isolatethread_t*, dxfg_feed_t*, dxfg_subscription_t*);

dxfg_event_type_t* dxfg_DXFeed_getLastEventIfSubscribed(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*);

dxfg_event_type_list* dxfg_DXFeed_getIndexedEventsIfSubscribed(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, char*);

dxfg_event_type_list* dxfg_DXFeed_getTimeSeriesIfSubscribed(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, long long int, long long int);

int dxfg_DXFeed_getLastEvent(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_type_t*);

int dxfg_DXFeed_getLastEvents(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_type_list*);

int dxfg_JavaObjectHandler_release(graal_isolatethread_t*, dxfg_java_object_handler*);

int dxfg_CList_JavaObjectHandler_release(graal_isolatethread_t*, dxfg_java_object_handler_list*);

dxfg_promise_t* dxfg_DXFeed_getLastEventPromise(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*);

dxfg_promise_list* dxfg_DXFeed_getLastEventsPromises(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_list*);

dxfg_promise_t* dxfg_DXFeed_getIndexedEventsPromise(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, dxfg_indexed_event_source_t*);

dxfg_promise_t* dxfg_DXFeed_getTimeSeriesPromise(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, long long int, long long int);

dxfg_promise_t* dxfg_Promises_allOf(graal_isolatethread_t*, dxfg_promise_list*);

int dxfg_Promise_isDone(graal_isolatethread_t*, dxfg_promise_t*);

int dxfg_Promise_hasResult(graal_isolatethread_t*, dxfg_promise_t*);

int dxfg_Promise_hasException(graal_isolatethread_t*, dxfg_promise_t*);

int dxfg_Promise_isCancelled(graal_isolatethread_t*, dxfg_promise_t*);

dxfg_event_type_t* dxfg_Promise_EventType_getResult(graal_isolatethread_t*, dxfg_promise_t*);

dxfg_event_type_list* dxfg_Promise_List_EventType_getResult(graal_isolatethread_t*, dxfg_promise_t*);

dxfg_exception_t* dxfg_Promise_getException(graal_isolatethread_t*, dxfg_promise_t*);

int dxfg_Promise_await(graal_isolatethread_t*, dxfg_promise_t*);

int dxfg_Promise_await2(graal_isolatethread_t*, dxfg_promise_t*, int);

int dxfg_Promise_awaitWithoutException(graal_isolatethread_t*, dxfg_promise_t*, int);

int dxfg_Promise_cancel(graal_isolatethread_t*, dxfg_promise_t*);

int dxfg_Promise_List_EventType_complete(graal_isolatethread_t*, dxfg_promise_t*, dxfg_event_type_list*);

int dxfg_Promise_EventType_complete(graal_isolatethread_t*, dxfg_promise_t*, dxfg_event_type_t*);

int dxfg_Promise_completeExceptionally(graal_isolatethread_t*, dxfg_promise_t*, dxfg_exception_t*);

int dxfg_Promise_whenDone(graal_isolatethread_t*, dxfg_promise_t*, dxfg_promise_handler_function, void*);

int dxfg_Promise_whenDoneAsync(graal_isolatethread_t*, dxfg_promise_t*, dxfg_promise_handler_function, void*, dxfg_executor_t*);

dxfg_promise_t* dxfg_Promise_completed(graal_isolatethread_t*, dxfg_promise_t*, dxfg_java_object_handler*);

dxfg_promise_t* dxfg_Promise_failed(graal_isolatethread_t*, dxfg_promise_t*, dxfg_exception_t*);

dxfg_publisher_t* dxfg_DXPublisher_getInstance(graal_isolatethread_t*);

int dxfg_DXPublisher_publishEvents(graal_isolatethread_t*, dxfg_publisher_t*, dxfg_event_type_list*);

dxfg_observable_subscription_t* dxfg_DXPublisher_getSubscription(graal_isolatethread_t*, dxfg_publisher_t*, dxfg_event_clazz_t);

int dxfg_ObservableSubscription_isClosed(graal_isolatethread_t*, dxfg_observable_subscription_t*);

dxfg_event_clazz_list_t* dxfg_ObservableSubscription_getEventTypes(graal_isolatethread_t*, dxfg_observable_subscription_t*);

int dxfg_ObservableSubscription_containsEventType(graal_isolatethread_t*, dxfg_observable_subscription_t*, dxfg_event_clazz_t);

int dxfg_ObservableSubscription_addChangeListener(graal_isolatethread_t*, dxfg_observable_subscription_t*, dxfg_observable_subscription_change_listener_t*);

int dxfg_ObservableSubscription_removeChangeListener(graal_isolatethread_t*, dxfg_observable_subscription_t*, dxfg_observable_subscription_change_listener_t*);

dxfg_subscription_t* dxfg_DXFeedSubscription_new(graal_isolatethread_t*, dxfg_event_clazz_t);

dxfg_subscription_t* dxfg_DXFeedSubscription_new2(graal_isolatethread_t*, dxfg_event_clazz_list_t*);

int dxfg_DXFeedSubscription_close(graal_isolatethread_t*, dxfg_subscription_t*);

int dxfg_DXFeedSubscription_clear(graal_isolatethread_t*, dxfg_subscription_t*);

int dxfg_DXFeedSubscription_addSymbols(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_list*);

int dxfg_DXFeedSubscription_addSymbol(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_t*);

int dxfg_DXFeedSubscription_removeSymbols(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_list*);

int dxfg_DXFeedSubscription_removeSymbol(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_t*);

dxfg_feed_event_listener_t* dxfg_DXFeedEventListener_new(graal_isolatethread_t*, dxfg_feed_event_listener_function, void*);

int dxfg_DXFeedSubscription_addEventListener(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_event_listener_t*);

int dxfg_DXFeedSubscription_removeEventListener(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_event_listener_t*);

int dxfg_DXFeedSubscription_attach(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_t*);

int dxfg_DXFeedSubscription_detach(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_t*);

int dxfg_DXFeedSubscription_isClosed(graal_isolatethread_t*, dxfg_subscription_t*);

dxfg_event_clazz_list_t* dxfg_DXFeedSubscription_getEventTypes(graal_isolatethread_t*, dxfg_subscription_t*);

int dxfg_DXFeedSubscription_containsEventType(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_event_clazz_t);

dxfg_symbol_list* dxfg_DXFeedSubscription_getSymbols(graal_isolatethread_t*, dxfg_subscription_t*);

int dxfg_DXFeedSubscription_setSymbol(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_t*);

int dxfg_DXFeedSubscription_setSymbols(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_list*);

dxfg_symbol_list* dxfg_DXFeedSubscription_getDecoratedSymbols(graal_isolatethread_t*, dxfg_subscription_t*);

dxfg_executor_t* dxfg_DXFeedSubscription_getExecutor(graal_isolatethread_t*, dxfg_subscription_t*);

int dxfg_DXFeedSubscription_setExecutor(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_executor_t*);

dxfg_observable_subscription_change_listener_t* dxfg_ObservableSubscriptionChangeListener_new(graal_isolatethread_t*, dxfg_ObservableSubscriptionChangeListener_function_symbolsAdded, dxfg_ObservableSubscriptionChangeListener_function_symbolsRemoved, dxfg_ObservableSubscriptionChangeListener_function_subscriptionClosed, void*);

int dxfg_DXFeedSubscription_addChangeListener(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_observable_subscription_change_listener_t*);

int dxfg_DXFeedSubscription_removeChangeListener(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_observable_subscription_change_listener_t*);

int dxfg_system_set_property(graal_isolatethread_t*, char*, char*);

char* dxfg_system_get_property(graal_isolatethread_t*, char*);

int dxfg_system_release_property(graal_isolatethread_t*, char*);

void vmLocatorSymbol(graal_isolatethread_t* thread);

#if defined(__cplusplus)
}
#endif
#endif
