#ifndef __LIBDXFEEDGRAALNATIVEAPI_H
#define __LIBDXFEEDGRAALNATIVEAPI_H

#include <graal_isolate_dynamic.h>


#if defined(__cplusplus)
extern "C" {
#endif

typedef dxfg_exception_t* (*dxfg_get_and_clear_thread_exception_t_fn_t)(graal_isolatethread_t*);

typedef void (*dxfg_Exception_release_fn_t)(graal_isolatethread_t*, dxfg_exception_t*);

typedef dxfg_endpoint_builder_t* (*dxfg_DXEndpoint_newBuilder_fn_t)(graal_isolatethread_t*);

typedef int (*dxfg_DXEndpoint_Builder_withRole_fn_t)(graal_isolatethread_t*, dxfg_endpoint_builder_t*, dxfg_endpoint_role_t);

typedef int (*dxfg_DXEndpoint_Builder_withName_fn_t)(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*);

typedef int (*dxfg_DXEndpoint_Builder_withProperty_fn_t)(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*, char*);

typedef int (*dxfg_DXEndpoint_Builder_withProperties_fn_t)(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*);

typedef int (*dxfg_DXEndpoint_Builder_supportsProperty_fn_t)(graal_isolatethread_t*, dxfg_endpoint_builder_t*, char*);

typedef dxfg_endpoint_t* (*dxfg_DXEndpoint_Builder_build_fn_t)(graal_isolatethread_t*, dxfg_endpoint_builder_t*);

typedef dxfg_endpoint_t* (*dxfg_DXEndpoint_getInstance_fn_t)(graal_isolatethread_t*);

typedef dxfg_endpoint_t* (*dxfg_DXEndpoint_getInstance2_fn_t)(graal_isolatethread_t*, dxfg_endpoint_role_t);

typedef dxfg_endpoint_t* (*dxfg_DXEndpoint_create_fn_t)(graal_isolatethread_t*);

typedef dxfg_endpoint_t* (*dxfg_DXEndpoint_create2_fn_t)(graal_isolatethread_t*, dxfg_endpoint_role_t);

typedef int (*dxfg_DXEndpoint_close_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_closeAndAwaitTermination_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_getRole_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_user_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*, char*);

typedef int (*dxfg_DXEndpoint_password_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*, char*);

typedef int (*dxfg_DXEndpoint_connect_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*, char*);

typedef int (*dxfg_DXEndpoint_reconnect_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_disconnect_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_disconnectAndClear_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_awaitProcessed_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_awaitNotConnected_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef int (*dxfg_DXEndpoint_getState_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef dxfg_endpoint_state_change_listener_t* (*dxfg_PropertyChangeListener_new_fn_t)(graal_isolatethread_t*, dxfg_endpoint_state_change_listener_func, void*);

typedef int (*dxfg_DXEndpoint_addStateChangeListener_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*, dxfg_endpoint_state_change_listener_t*);

typedef int (*dxfg_DXEndpoint_removeStateChangeListener_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*, dxfg_endpoint_state_change_listener_t*);

typedef dxfg_feed_t* (*dxfg_DXEndpoint_getFeed_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef dxfg_publisher_t* (*dxfg_DXEndpoint_getPublisher_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef dxfg_executor_t* (*dxfg_Executors_newFixedThreadPool_fn_t)(graal_isolatethread_t*, int, char*);

typedef int (*dxfg_DXEndpoint_executor_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*, dxfg_executor_t*);

typedef dxfg_event_clazz_list_t* (*dxfg_DXEndpoint_getEventTypes_fn_t)(graal_isolatethread_t*, dxfg_endpoint_t*);

typedef dxfg_symbol_t* (*dxfg_Symbol_new_fn_t)(graal_isolatethread_t*, char*, dxfg_symbol_type_t);

typedef int (*dxfg_Symbol_release_fn_t)(graal_isolatethread_t*, dxfg_symbol_t*);

typedef dxfg_event_type_t* (*dxfg_EventType_new_fn_t)(graal_isolatethread_t*, char*, dxfg_event_clazz_t);

typedef int (*dxfg_EventType_release_fn_t)(graal_isolatethread_t*, dxfg_event_type_t*);

typedef int (*dxfg_CList_EventType_release_fn_t)(graal_isolatethread_t*, dxfg_event_type_list*);

typedef int (*dxfg_CList_EventClazz_release_fn_t)(graal_isolatethread_t*, dxfg_event_clazz_list_t*);

typedef int (*dxfg_CList_symbol_release_fn_t)(graal_isolatethread_t*, dxfg_symbol_list*);

typedef dxfg_indexed_event_source_t* (*dxfg_IndexedEventSource_new_fn_t)(graal_isolatethread_t*, char*);

typedef int (*dxfg_IndexedEventSource_release_fn_t)(graal_isolatethread_t*, dxfg_indexed_event_source_t*);

typedef dxfg_indexed_event_source_t* (*dxfg_IndexedEvent_getSource_fn_t)(graal_isolatethread_t*, dxfg_event_type_t*);

typedef dxfg_feed_t* (*dxfg_DXFeed_getInstance_fn_t)(graal_isolatethread_t*);

typedef dxfg_subscription_t* (*dxfg_DXFeed_createSubscription_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t);

typedef dxfg_subscription_t* (*dxfg_DXFeed_createSubscription2_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_list_t*);

typedef dxfg_time_series_subscription_t* (*dxfg_DXFeed_createTimeSeriesSubscription_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t);

typedef dxfg_time_series_subscription_t* (*dxfg_DXFeed_createTimeSeriesSubscription2_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_list_t*);

typedef int (*dxfg_DXFeedTimeSeriesSubscription_setFromTime_fn_t)(graal_isolatethread_t*, dxfg_time_series_subscription_t*, long long int);

typedef int (*dxfg_DXFeed_attachSubscription_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_subscription_t*);

typedef int (*dxfg_DXFeed_detachSubscription_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_subscription_t*);

typedef int (*dxfg_DXFeed_detachSubscriptionAndClear_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_subscription_t*);

typedef dxfg_event_type_t* (*dxfg_DXFeed_getLastEventIfSubscribed_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*);

typedef dxfg_event_type_list* (*dxfg_DXFeed_getIndexedEventsIfSubscribed_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, char*);

typedef dxfg_event_type_list* (*dxfg_DXFeed_getTimeSeriesIfSubscribed_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, long long int, long long int);

typedef int (*dxfg_DXFeed_getLastEvent_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_type_t*);

typedef int (*dxfg_DXFeed_getLastEvents_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_type_list*);

typedef int (*dxfg_JavaObjectHandler_release_fn_t)(graal_isolatethread_t*, dxfg_java_object_handler*);

typedef int (*dxfg_CList_JavaObjectHandler_release_fn_t)(graal_isolatethread_t*, dxfg_java_object_handler_list*);

typedef dxfg_promise_t* (*dxfg_DXFeed_getLastEventPromise_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*);

typedef dxfg_promise_list* (*dxfg_DXFeed_getLastEventsPromises_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_list*);

typedef dxfg_promise_t* (*dxfg_DXFeed_getIndexedEventsPromise_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, dxfg_indexed_event_source_t*);

typedef dxfg_promise_t* (*dxfg_DXFeed_getTimeSeriesPromise_fn_t)(graal_isolatethread_t*, dxfg_feed_t*, dxfg_event_clazz_t, dxfg_symbol_t*, long long int, long long int);

typedef dxfg_promise_t* (*dxfg_Promises_allOf_fn_t)(graal_isolatethread_t*, dxfg_promise_list*);

typedef int (*dxfg_Promise_isDone_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef int (*dxfg_Promise_hasResult_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef int (*dxfg_Promise_hasException_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef int (*dxfg_Promise_isCancelled_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef dxfg_event_type_t* (*dxfg_Promise_EventType_getResult_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef dxfg_event_type_list* (*dxfg_Promise_List_EventType_getResult_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef dxfg_exception_t* (*dxfg_Promise_getException_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef int (*dxfg_Promise_await_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef int (*dxfg_Promise_await2_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, int);

typedef int (*dxfg_Promise_awaitWithoutException_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, int);

typedef int (*dxfg_Promise_cancel_fn_t)(graal_isolatethread_t*, dxfg_promise_t*);

typedef int (*dxfg_Promise_List_EventType_complete_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, dxfg_event_type_list*);

typedef int (*dxfg_Promise_EventType_complete_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, dxfg_event_type_t*);

typedef int (*dxfg_Promise_completeExceptionally_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, dxfg_exception_t*);

typedef int (*dxfg_Promise_whenDone_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, dxfg_promise_handler_function, void*);

typedef int (*dxfg_Promise_whenDoneAsync_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, dxfg_promise_handler_function, void*, dxfg_executor_t*);

typedef dxfg_promise_t* (*dxfg_Promise_completed_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, dxfg_java_object_handler*);

typedef dxfg_promise_t* (*dxfg_Promise_failed_fn_t)(graal_isolatethread_t*, dxfg_promise_t*, dxfg_exception_t*);

typedef dxfg_publisher_t* (*dxfg_DXPublisher_getInstance_fn_t)(graal_isolatethread_t*);

typedef int (*dxfg_DXPublisher_publishEvents_fn_t)(graal_isolatethread_t*, dxfg_publisher_t*, dxfg_event_type_list*);

typedef dxfg_observable_subscription_t* (*dxfg_DXPublisher_getSubscription_fn_t)(graal_isolatethread_t*, dxfg_publisher_t*, dxfg_event_clazz_t);

typedef int (*dxfg_ObservableSubscription_isClosed_fn_t)(graal_isolatethread_t*, dxfg_observable_subscription_t*);

typedef dxfg_event_clazz_list_t* (*dxfg_ObservableSubscription_getEventTypes_fn_t)(graal_isolatethread_t*, dxfg_observable_subscription_t*);

typedef int (*dxfg_ObservableSubscription_containsEventType_fn_t)(graal_isolatethread_t*, dxfg_observable_subscription_t*, dxfg_event_clazz_t);

typedef int (*dxfg_ObservableSubscription_addChangeListener_fn_t)(graal_isolatethread_t*, dxfg_observable_subscription_t*, dxfg_observable_subscription_change_listener_t*);

typedef int (*dxfg_ObservableSubscription_removeChangeListener_fn_t)(graal_isolatethread_t*, dxfg_observable_subscription_t*, dxfg_observable_subscription_change_listener_t*);

typedef dxfg_subscription_t* (*dxfg_DXFeedSubscription_new_fn_t)(graal_isolatethread_t*, dxfg_event_clazz_t);

typedef dxfg_subscription_t* (*dxfg_DXFeedSubscription_new2_fn_t)(graal_isolatethread_t*, dxfg_event_clazz_list_t*);

typedef int (*dxfg_DXFeedSubscription_close_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*);

typedef int (*dxfg_DXFeedSubscription_clear_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*);

typedef int (*dxfg_DXFeedSubscription_addSymbols_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_list*);

typedef int (*dxfg_DXFeedSubscription_addSymbol_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_t*);

typedef int (*dxfg_DXFeedSubscription_removeSymbols_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_list*);

typedef int (*dxfg_DXFeedSubscription_removeSymbol_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_t*);

typedef dxfg_feed_event_listener_t* (*dxfg_DXFeedEventListener_new_fn_t)(graal_isolatethread_t*, dxfg_feed_event_listener_function, void*);

typedef int (*dxfg_DXFeedSubscription_addEventListener_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_event_listener_t*);

typedef int (*dxfg_DXFeedSubscription_removeEventListener_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_event_listener_t*);

typedef int (*dxfg_DXFeedSubscription_attach_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_t*);

typedef int (*dxfg_DXFeedSubscription_detach_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_feed_t*);

typedef int (*dxfg_DXFeedSubscription_isClosed_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*);

typedef dxfg_event_clazz_list_t* (*dxfg_DXFeedSubscription_getEventTypes_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*);

typedef int (*dxfg_DXFeedSubscription_containsEventType_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_event_clazz_t);

typedef dxfg_symbol_list* (*dxfg_DXFeedSubscription_getSymbols_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*);

typedef int (*dxfg_DXFeedSubscription_setSymbol_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_t*);

typedef int (*dxfg_DXFeedSubscription_setSymbols_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_symbol_list*);

typedef dxfg_symbol_list* (*dxfg_DXFeedSubscription_getDecoratedSymbols_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*);

typedef dxfg_executor_t* (*dxfg_DXFeedSubscription_getExecutor_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*);

typedef int (*dxfg_DXFeedSubscription_setExecutor_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_executor_t*);

typedef dxfg_observable_subscription_change_listener_t* (*dxfg_ObservableSubscriptionChangeListener_new_fn_t)(graal_isolatethread_t*, dxfg_ObservableSubscriptionChangeListener_function_symbolsAdded, dxfg_ObservableSubscriptionChangeListener_function_symbolsRemoved, dxfg_ObservableSubscriptionChangeListener_function_subscriptionClosed, void*);

typedef int (*dxfg_DXFeedSubscription_addChangeListener_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_observable_subscription_change_listener_t*);

typedef int (*dxfg_DXFeedSubscription_removeChangeListener_fn_t)(graal_isolatethread_t*, dxfg_subscription_t*, dxfg_observable_subscription_change_listener_t*);

typedef int (*dxfg_system_set_property_fn_t)(graal_isolatethread_t*, char*, char*);

typedef char* (*dxfg_system_get_property_fn_t)(graal_isolatethread_t*, char*);

typedef int (*dxfg_system_release_property_fn_t)(graal_isolatethread_t*, char*);

typedef void (*vmLocatorSymbol_fn_t)(graal_isolatethread_t* thread);

#if defined(__cplusplus)
}
#endif
#endif
